# coding: utf-8

# flake8: noqa

"""
    MetaCopier API

    Explore the power of the MetaCopier API! Our RESTful API offers scalable and secure access to accounts, projects, and more. Get started quickly with authentication, explore endpoints, and access code samples in various languages.<br/><br/>All dates are in ISO 8601<br/><br/>This API is not designed for real-time communication purposes. For instance, continuously polling account information such as open positions every second is not recommended.<br/><br/>Our frontend uses this API, so you can look at the requests on our frontend for examples.

    The version of the OpenAPI document: 0.9.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from metacopier_api.api.account_api_api import AccountAPIApi
from metacopier_api.api.project_api_api import ProjectAPIApi
from metacopier_api.api.trading_api_api import TradingAPIApi
from metacopier_api.api.type_api_api import TypeAPIApi

# import ApiClient
from metacopier_api.api_response import ApiResponse
from metacopier_api.api_client import ApiClient
from metacopier_api.configuration import Configuration
from metacopier_api.exceptions import OpenApiException
from metacopier_api.exceptions import ApiTypeError
from metacopier_api.exceptions import ApiValueError
from metacopier_api.exceptions import ApiKeyError
from metacopier_api.exceptions import ApiAttributeError
from metacopier_api.exceptions import ApiException

# import models into sdk package
from metacopier_api.models.account_dto import AccountDTO
from metacopier_api.models.account_information_dto import AccountInformationDTO
from metacopier_api.models.account_status_dto import AccountStatusDTO
from metacopier_api.models.account_type_dto import AccountTypeDTO
from metacopier_api.models.copier_dto import CopierDTO
from metacopier_api.models.currency_type_dto import CurrencyTypeDTO
from metacopier_api.models.feature_copier_filter_dto import FeatureCopierFilterDTO
from metacopier_api.models.feature_dto import FeatureDTO
from metacopier_api.models.feature_keep_alive_trade_dto import FeatureKeepAliveTradeDTO
from metacopier_api.models.feature_permitted_symbols_dto import FeaturePermittedSymbolsDTO
from metacopier_api.models.feature_setting_dto import FeatureSettingDTO
from metacopier_api.models.feature_telegram_notification_dto import FeatureTelegramNotificationDTO
from metacopier_api.models.feature_type_dto import FeatureTypeDTO
from metacopier_api.models.invoice_dto import InvoiceDTO
from metacopier_api.models.log_dto import LogDTO
from metacopier_api.models.log_type_dto import LogTypeDTO
from metacopier_api.models.payment_method_dto import PaymentMethodDTO
from metacopier_api.models.position_dto import PositionDTO
from metacopier_api.models.position_request_dto import PositionRequestDTO
from metacopier_api.models.project_dto import ProjectDTO
from metacopier_api.models.region_dto import RegionDTO
from metacopier_api.models.risk_limit_dto import RiskLimitDTO
from metacopier_api.models.risk_limit_status_dto import RiskLimitStatusDTO
from metacopier_api.models.risk_type_dto import RiskTypeDTO
from metacopier_api.models.scale_type_dto import ScaleTypeDTO
from metacopier_api.models.strategy_dto import StrategyDTO
from metacopier_api.models.symbol_mapping_dto import SymbolMappingDTO
from metacopier_api.models.telegram_notification_dto import TelegramNotificationDTO
