# coding: utf-8

"""
    MetaCopier API

    Explore the power of the MetaCopier API! Our RESTful API offers scalable and secure access to accounts, projects, and more. Get started quickly with authentication, explore endpoints, and access code samples in various languages.<br/><br/>All dates are in ISO 8601<br/><br/>This API is not designed for real-time communication purposes. For instance, continuously polling account information such as open positions every second is not recommended.<br/><br/>Our frontend uses this API, so you can look at the requests on our frontend for examples.

    The version of the OpenAPI document: 0.9.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from metacopier_api.models.feature_setting_dto import FeatureSettingDTO
from metacopier_api.models.feature_type_dto import FeatureTypeDTO
from typing import Optional, Set
from typing_extensions import Self

class FeatureDTO(BaseModel):
    """
    FeatureDTO
    """ # noqa: E501
    account_id: Optional[StrictStr] = Field(default=None, description="You have to set it during resource creation, after that, it is only read-only", alias="accountId")
    copier_id: Optional[StrictStr] = Field(default=None, description="You have to set it during resource creation, after that, it is only read-only", alias="copierId")
    created: Optional[datetime] = Field(default=None, description="ISO 8601")
    id: Optional[StrictStr] = None
    project_id: Optional[StrictStr] = Field(default=None, description="You have to set it during resource creation, after that, it is only read-only", alias="projectId")
    setting: FeatureSettingDTO
    type: FeatureTypeDTO
    __properties: ClassVar[List[str]] = ["accountId", "copierId", "created", "id", "projectId", "setting", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FeatureDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "created",
            "id",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of setting
        if self.setting:
            _dict['setting'] = self.setting.to_dict()
        # override the default output from pydantic by calling `to_dict()` of type
        if self.type:
            _dict['type'] = self.type.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FeatureDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountId": obj.get("accountId"),
            "copierId": obj.get("copierId"),
            "created": obj.get("created"),
            "id": obj.get("id"),
            "projectId": obj.get("projectId"),
            "setting": FeatureSettingDTO.from_dict(obj["setting"]) if obj.get("setting") is not None else None,
            "type": FeatureTypeDTO.from_dict(obj["type"]) if obj.get("type") is not None else None
        })
        return _obj


