# coding: utf-8

"""
    MetaCopier API

    Explore the power of the MetaCopier API! Our RESTful API offers scalable and secure access to accounts, projects, and more. Get started quickly with authentication, explore endpoints, and access code samples in various languages.<br/><br/>All dates are in ISO 8601<br/><br/>This API is not designed for real-time communication purposes. For instance, continuously polling account information such as open positions every second is not recommended.<br/><br/>Our frontend uses this API, so you can look at the requests on our frontend for examples.

    The version of the OpenAPI document: 0.9.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from metacopier_api.models.currency_type_dto import CurrencyTypeDTO
from typing import Optional, Set
from typing_extensions import Self

class InvoiceDTO(BaseModel):
    """
    InvoiceDTO
    """ # noqa: E501
    amount: Optional[Union[StrictFloat, StrictInt]] = None
    created: Optional[datetime] = Field(default=None, description="ISO 8601")
    currency_type: CurrencyTypeDTO = Field(alias="currencyType")
    description: Optional[StrictStr] = None
    description_position: Optional[StrictStr] = Field(default=None, alias="descriptionPosition")
    discount: Optional[Union[StrictFloat, StrictInt]] = None
    due_date: Optional[datetime] = Field(default=None, description="ISO 8601", alias="dueDate")
    id: Optional[StrictStr] = None
    invoice_number: Optional[StrictStr] = Field(default=None, alias="invoiceNumber")
    invoice_payment_url: Optional[StrictStr] = Field(default=None, alias="invoicePaymentUrl")
    invoice_pdf_url: Optional[StrictStr] = Field(default=None, alias="invoicePdfUrl")
    project_id: Optional[StrictStr] = Field(default=None, alias="projectId")
    project_name: Optional[StrictStr] = Field(default=None, alias="projectName")
    status: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["amount", "created", "currencyType", "description", "descriptionPosition", "discount", "dueDate", "id", "invoiceNumber", "invoicePaymentUrl", "invoicePdfUrl", "projectId", "projectName", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of InvoiceDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "amount",
            "created",
            "description",
            "description_position",
            "discount",
            "due_date",
            "id",
            "invoice_number",
            "invoice_payment_url",
            "invoice_pdf_url",
            "project_id",
            "project_name",
            "status",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of currency_type
        if self.currency_type:
            _dict['currencyType'] = self.currency_type.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of InvoiceDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amount": obj.get("amount"),
            "created": obj.get("created"),
            "currencyType": CurrencyTypeDTO.from_dict(obj["currencyType"]) if obj.get("currencyType") is not None else None,
            "description": obj.get("description"),
            "descriptionPosition": obj.get("descriptionPosition"),
            "discount": obj.get("discount"),
            "dueDate": obj.get("dueDate"),
            "id": obj.get("id"),
            "invoiceNumber": obj.get("invoiceNumber"),
            "invoicePaymentUrl": obj.get("invoicePaymentUrl"),
            "invoicePdfUrl": obj.get("invoicePdfUrl"),
            "projectId": obj.get("projectId"),
            "projectName": obj.get("projectName"),
            "status": obj.get("status")
        })
        return _obj


