# coding: utf-8

"""
    MetaCopier API

    Explore the power of the MetaCopier API! Our RESTful API offers scalable and secure access to accounts, projects, and more. Get started quickly with authentication, explore endpoints, and access code samples in various languages.<br/><br/>All dates are in ISO 8601<br/><br/>This API is not designed for real-time communication purposes. For instance, continuously polling account information such as open positions every second is not recommended.<br/><br/>Our frontend uses this API, so you can look at the requests on our frontend for examples.

    The version of the OpenAPI document: 0.9.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from metacopier_api.models.currency_type_dto import CurrencyTypeDTO
from metacopier_api.models.payment_method_dto import PaymentMethodDTO
from typing import Optional, Set
from typing_extensions import Self

class ProjectDTO(BaseModel):
    """
    ProjectDTO
    """ # noqa: E501
    balance: Optional[Union[StrictFloat, StrictInt]] = None
    billing_city: Annotated[str, Field(min_length=0, strict=True, max_length=255)] = Field(alias="billingCity")
    billing_company_name: Annotated[str, Field(min_length=0, strict=True, max_length=255)] = Field(alias="billingCompanyName")
    billing_country: Annotated[str, Field(min_length=0, strict=True, max_length=255)] = Field(alias="billingCountry")
    billing_name: Annotated[str, Field(min_length=0, strict=True, max_length=255)] = Field(alias="billingName")
    billing_postcode: Annotated[str, Field(min_length=0, strict=True, max_length=255)] = Field(alias="billingPostcode")
    billing_street: Annotated[str, Field(min_length=0, strict=True, max_length=255)] = Field(alias="billingStreet")
    blocked: Optional[StrictBool] = None
    currency_type: CurrencyTypeDTO = Field(alias="currencyType")
    dedicated: StrictBool = Field(description="You have to set it during resource creation, after that, it is only read-only. See pricing on our webpage for more information")
    id: Optional[StrictStr] = None
    name: Annotated[str, Field(min_length=0, strict=True, max_length=255)]
    payment_method: Optional[PaymentMethodDTO] = Field(default=None, alias="paymentMethod")
    __properties: ClassVar[List[str]] = ["balance", "billingCity", "billingCompanyName", "billingCountry", "billingName", "billingPostcode", "billingStreet", "blocked", "currencyType", "dedicated", "id", "name", "paymentMethod"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProjectDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "balance",
            "blocked",
            "id",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of currency_type
        if self.currency_type:
            _dict['currencyType'] = self.currency_type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of payment_method
        if self.payment_method:
            _dict['paymentMethod'] = self.payment_method.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProjectDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "balance": obj.get("balance"),
            "billingCity": obj.get("billingCity"),
            "billingCompanyName": obj.get("billingCompanyName"),
            "billingCountry": obj.get("billingCountry"),
            "billingName": obj.get("billingName"),
            "billingPostcode": obj.get("billingPostcode"),
            "billingStreet": obj.get("billingStreet"),
            "blocked": obj.get("blocked"),
            "currencyType": CurrencyTypeDTO.from_dict(obj["currencyType"]) if obj.get("currencyType") is not None else None,
            "dedicated": obj.get("dedicated") if obj.get("dedicated") is not None else False,
            "id": obj.get("id"),
            "name": obj.get("name"),
            "paymentMethod": PaymentMethodDTO.from_dict(obj["paymentMethod"]) if obj.get("paymentMethod") is not None else None
        })
        return _obj


