# coding: utf-8

"""
    MetaCopier API

    Explore the power of the MetaCopier API! Our RESTful API offers scalable and secure access to accounts, projects, and more. Get started quickly with authentication, explore endpoints, and access code samples in various languages.<br/><br/>All dates are in ISO 8601<br/><br/>This API is not designed for real-time communication purposes. For instance, continuously polling account information such as open positions every second is not recommended.<br/><br/>Our frontend uses this API, so you can look at the requests on our frontend for examples.

    The version of the OpenAPI document: 0.9.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from metacopier_api.models.risk_type_dto import RiskTypeDTO
from typing import Optional, Set
from typing_extensions import Self

class RiskLimitDTO(BaseModel):
    """
    RiskLimitDTO
    """ # noqa: E501
    account_id: Optional[StrictStr] = Field(default=None, description="You have to set it during resource creation, after that, it is only read-only", alias="accountId")
    active: Optional[StrictBool] = True
    close_all_open_positions: Optional[StrictBool] = Field(default=True, description="If set to 'yes,' all positions will be closed when the limit is reached. If set to 'false', new trades will not be opened", alias="closeAllOpenPositions")
    copier_id: Optional[StrictStr] = Field(default=None, description="You have to set it during resource creation, after that, it is only read-only", alias="copierId")
    fulfill_seconds: Optional[StrictInt] = Field(default=0, description="If set to 5, it means that if the limit is reached and stays over the limit for 5 seconds, the risk limit will be activated; otherwise, the limit will remain deactivated", alias="fulfillSeconds")
    id: Optional[StrictStr] = None
    reset_time: Optional[datetime] = Field(default=None, description="ISO 8601. Set the reset time for calculation (see riskType). Only used for 1-3 risk type.", alias="resetTime")
    risk_limit: Union[Annotated[float, Field(le=1.0, strict=True, ge=0.0)], Annotated[int, Field(le=1, strict=True, ge=0)]] = Field(description="0.215 for 21.5%", alias="riskLimit")
    risk_type: RiskTypeDTO = Field(alias="riskType")
    __properties: ClassVar[List[str]] = ["accountId", "active", "closeAllOpenPositions", "copierId", "fulfillSeconds", "id", "resetTime", "riskLimit", "riskType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RiskLimitDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of risk_type
        if self.risk_type:
            _dict['riskType'] = self.risk_type.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RiskLimitDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountId": obj.get("accountId"),
            "active": obj.get("active") if obj.get("active") is not None else True,
            "closeAllOpenPositions": obj.get("closeAllOpenPositions") if obj.get("closeAllOpenPositions") is not None else True,
            "copierId": obj.get("copierId"),
            "fulfillSeconds": obj.get("fulfillSeconds") if obj.get("fulfillSeconds") is not None else 0,
            "id": obj.get("id"),
            "resetTime": obj.get("resetTime"),
            "riskLimit": obj.get("riskLimit"),
            "riskType": RiskTypeDTO.from_dict(obj["riskType"]) if obj.get("riskType") is not None else None
        })
        return _obj


