# coding: utf-8

"""
    MetaCopier API

    Explore the power of the MetaCopier API! Our RESTful API offers scalable and secure access to accounts, projects, and more. Get started quickly with authentication, explore endpoints, and access code samples in various languages.<br/><br/>All dates are in ISO 8601<br/><br/>This API is not designed for real-time communication purposes. For instance, continuously polling account information such as open positions every second is not recommended.<br/><br/>Our frontend uses this API, so you can look at the requests on our frontend for examples.

    The version of the OpenAPI document: 0.9.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from metacopier_api.models.log_type_dto import LogTypeDTO
from typing import Optional, Set
from typing_extensions import Self

class TelegramNotificationDTO(BaseModel):
    """
    List of telegram notifications
    """ # noqa: E501
    account_ids: Optional[List[StrictStr]] = Field(default=None, description="Only the account IDs listed here will receive notifications", alias="accountIds")
    alias_mapping: Optional[Dict[str, StrictStr]] = Field(default=None, alias="aliasMapping")
    log_level: LogTypeDTO = Field(alias="logLevel")
    username: StrictStr = Field(description="Enter the Telegram username (e.g. @john98734)")
    __properties: ClassVar[List[str]] = ["accountIds", "aliasMapping", "logLevel", "username"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TelegramNotificationDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "alias_mapping",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of log_level
        if self.log_level:
            _dict['logLevel'] = self.log_level.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TelegramNotificationDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountIds": obj.get("accountIds"),
            "aliasMapping": obj.get("aliasMapping"),
            "logLevel": LogTypeDTO.from_dict(obj["logLevel"]) if obj.get("logLevel") is not None else None,
            "username": obj.get("username")
        })
        return _obj


